100 'Lawson Labs, Inc.
110 '5700 Raibe Road
120 'Columbia Falls, Montana   59912
130 '
140 'phone 406 387-5355
150 '
160 'Model 134 16-bit A/D
170 '
180 'FASTSAMP fast sampling software   Rev E             November 21, 1988
190 '
200 CLEAR ,&HFD00' reserve 768 bytes for machine code
210 DEF SEG' Select default segment
220 '
230 BLOAD "samp", &HFD00' machine code routines
240 KEY OFF: CLS
250 ' The sampling run is defined in the sample% array.
260 DIM SAMPLE%(84)
270 DIM CODE%(8)' array holds machine code
280 ON ERROR GOTO 2120
290 BLOAD "samarray", VARPTR(SAMPLE%(1))' load last SAMPLE% array
300 ON ERROR GOTO 0
310 GOSUB 2300 ' timing
320 TFLAG%=1
330 'sample%(0) not used so that OPTION BASE 0 or 1 may be selected
340 'sample%(1) through sample%(64)  Each scan is of 1 to 64 points. The                        sequence of channels & control codes are stored here.
350 'sample%(65) the first control code (sample%(1)) is repeated after the                       last. For 64-channel scans, that goes here.
360 'sample%(66) A/D Converter address code (ADC) determined by DIP switches
370 'sample%(67) number of bits resolution (8 or 16)
380 'sample%(68) Interrupt flag 1=interrupts on during sampling, 0=off
390 'sample%(69) Starting memory segment for data table
400 'sample%(70) scans/second (nominal)
410 'sample%(71) Interchannel delay for high impedance voltage sources
420 'sample%(72) Number of readings to average for each datapoint
430 'sample%(73) The power of 2 of sample%(72)
440 'sample%(74) Interscan delay
450 'sample%(75) TICK in nanoseconds (Smallest unit for delay loop)
460 'sample%(76) Final ES: ie the segment address one byte past the end of the                   data table
470 'sample%(77) Final SI: ie the displacement into the final segment
480 'sample%(78) Number of data points per scan * 2
490 'sample%(79) & (80) are not used by the called routine
500 'sample%(79) Int(number of scans/512)
510 'sample%(80) remainder of scans from sample%(79) * 512
520 'sample%(81) & (82) spare
530 'sample%(83) & (84) workspace for temporary storage
540 '
550 TICK= SAMPLE%(75) * 10^-9
555 SCANS = SAMPLE%(80) + SAMPLE%(79) * 512
560 IF SAMPLE%(66) = 0 THEN 590
570 CLS: PRINT"ADC=";SAMPLE%(66);" Y/N?":A$=INPUT$(1):                              IF A$="Y"OR A$="y" THEN 600
580 IF A$="N" OR A$="n" THEN 590 ELSE 570
590 CLS:INPUT "Enter ADC (check your manual) ";SAMPLE%(66)
600 IF SAMPLE%(67) = 0 THEN SAMPLE%(67) = 16
610 CLS: PRINT SAMPLE%(67);"-bit resolution Y/N?":A$=INPUT$(1):                     IF A$="Y"OR A$="y" THEN 640
620 IF A$="N" OR A$="n" THEN 630 ELSE 600
630 SAMPLE%(67)= (SAMPLE%(67) MOD 16) + 8: TFLAG%=1: GOTO 610
640 CLS:IF SAMPLE%(68)=1 THEN PRINT"Interrupts On"; ELSE PRINT "Interrupts Off";
650 PRINT" Y/N?":A$=INPUT$(1):IF A$="Y" OR A$="y" THEN 680
660 IF A$="N" OR A$="n" THEN 670 ELSE 640
670 SAMPLE%(68)=ABS(SAMPLE%(68)-1): GOTO 640
680 X=SAMPLE%(69):IF X<0 THEN X=X+65536!
690 STARTTABLE = X * 16
700 CLS: DEF SEG= 0: LOCATE 25,10: PRINT "Start at or above";(PEEK(&H510) +         PEEK(&H511) * 256) * 16 + 65552!: DEF SEG
710 LOCATE 1,1: PRINT "starting memory address for data table= ";STARTTABLE;" Y/N?": A$=INPUT$(1): IF A$="Y"OR A$="y" THEN 770
720 IF A$="N" OR A$="n" THEN 730 ELSE 680
730 PRINT: INPUT "Enter new starting memory address for data table ";STARTTABLE
740 SA = INT(STARTTABLE/16): STARTTABLE = SA * 16
750 IF SA > 32767 THEN SA = SA - 65536!
760 SAMPLE%(69)=SA
770 IF SAMPLE%(67)=8 THEN SAMPLE%(71)=0: SAMPLE%(72)=1: SAMPLE%(73)=0: GOTO 880
780 CLS: PRINT "interchannel delay count= ";SAMPLE%(71);" (";TICK * SAMPLE%(71)    * 1000; ") milliseconds  Y/N?":A$=INPUT$(1): IF    A$="Y"OR A$="y" THEN 810
790 IF A$="N" OR A$="n" THEN 800 ELSE 770
800 CLS:INPUT"Enter Interchannel delay ";SAMPLE%(71): TFLAG%= 1: GOTO 780
810 IF SAMPLE%(72) = 0 THEN SAMPLE%(72) = 1
820 CLS: PRINT "average ";SAMPLE%(72);" samples/data point Y/N?": A$=INPUT$(1):     IF A$="Y" OR A$="y" THEN 870
830 IF A$="N" OR A$="n" THEN 840 ELSE 810
840 CLS:P=0:INPUT"Enter samples/point ";SAMPLE%(72): TFLAG%=1
850 IF SAMPLE%(72)/2 <1 THEN SAMPLE%(73)=P:SAMPLE%(72)=2^P: GOTO 810
860 P=P+1: SAMPLE%(72)=SAMPLE%(72)/2: GOTO 850
870 IF SAMPLE%(71)=0 AND SAMPLE%(73)>0 THEN SAMPLE%(71)=1
880 IF SAMPLE%(78) = 0 THEN SAMPLE%(78) = 2
890 CLS: PRINT "data points/scan= "; SAMPLE%(78)/2;" Y/N?":A$=INPUT$(1): IF A$=     "Y" OR A$="y" THEN 930
900 IF A$="N" OR A$="n" THEN 910 ELSE 870
910 CLS:INPUT"Enter number of data points per scan ";X: SAMPLE%(78)=X*2
920 TFLAG%=1
930 IF SAMPLE%(67)=8 THEN CT=.00004 ELSE CT=.00008
940 IF SAMPLE%(71) + SAMPLE%(73) <> 0 THEN K1=TICK*11: K2=TICK*8: GOTO 980
950 K1=0
960 IF SAMPLE%(67)=8 THEN IF SAMPLE%(78)=2 THEN K2 =0 ELSE K2=TICK*3: K1=TICK*5
970 IF SAMPLE%(67)=16 THEN IF SAMPLE%(78)=2 THEN K2 = 0 ELSE K2=TICK*5
980 QRATE = 1/((SAMPLE%(78)/2)*(TICK* SAMPLE%(71)+CT*SAMPLE%(72) + K1) + K2)
990 IF TFLAG%= 1 THEN GOSUB 2780: OVERHEAD= ELPS: SAMPLE%(74)= TEMPDELAY%
1000 IF OVERHEAD > 1.007 THEN PRINT "Max rate= ";1/OVERHEAD: PRINT "Reduce averaging or delay. Press space to continue": A$= INPUT$(1): GOTO 780
1010 NRATE%= SAMPLE%(70)
1020 IF OVERHEAD /(1/NRATE%) > 1.007 THEN NRATE%= 1/OVERHEAD: TRYS%= 0
1030 IF NRATE%= 0 THEN NRATE%= 1
1040 CLS: PRINT "scan rate= "; NRATE%;" scans/second Y/N?":A$=INPUT$(1): IF A$="Y"     OR A$="y" THEN 1070
1050 IF A$="N" OR A$="n" THEN 1060 ELSE 1040
1060 CLS:INPUT"Enter scan rate ";NRATE%: TRYS%=0
1070 SAMPLE%(70)= NRATE%
1080 PERIOD = 1/NRATE%
1090 IF TRYS% <> 0 THEN 1130
1100 DELAY= FIX((PERIOD-OVERHEAD)/(.000038 + TICK * 2))
1110 IF DELAY < 0 THEN PRINT:PRINT"Maximum rate equals ";(1/OVERHEAD);: PRINT        "Press space to continue";:A$=INPUT$(1): GOTO 1060
1120 SAMPLE%(74)= DELAY
1130 IF SCANS = 0 THEN SCANS = 1
1140 IF SCANS = 0 THEN SCANS = 1
1150 CLS: PRINT SCANS;" scans per sampling run Y/N?":A$=INPUT$(1):IF A$="Y" OR A$    ="y" THEN 1180
1160 IF A$="N" OR A$="n" THEN 1170 ELSE 1130
1170 CLS:INPUT"Enter scans per sampling run ";SCANS
1180 GOSUB 1190: GOTO 1300
1190 SAMPLE%(79) = INT(SCANS/512): SAMPLE%(80) = SCANS - SAMPLE%(79) * 512
1200 TABLELENGTH= SCANS*SAMPLE%(78)/2: IF SAMPLE%(67)=16 THEN TABLELENGTH=             TABLELENGTH * 2
1210 ENDTABLE = STARTTABLE + TABLELENGTH
1220 X=STARTTABLE/16 + INT(TABLELENGTH/65536!)*4096
1230 IF X>32767 THEN X=X-65536!
1240 IF X>32767 THEN SCANS= INT(SCANS - (X - 32000)/ SAMPLE%(78)): GOTO 1190
1250 SAMPLE%(76)=X
1260 X=TABLELENGTH - INT(TABLELENGTH/65536!)*65536!
1270 IF X>32767 THEN X=X-65536!
1280 SAMPLE%(77)=X
1290 RETURN
1300 CLS:PRINT "adc=";SAMPLE%(66)
1310 PRINT SAMPLE%(67);"-bit resolution"
1320 PRINT "Interrupts o";:IF SAMPLE%(68)=1 THEN PRINT"n" ELSE PRINT "ff"
1330 PRINT "Inter-channel delay count=";SAMPLE%(71);" (or ";SAMPLE%(71) *            SAMPLE%(75) * 10^-6; " milliseconds)"
1340 PRINT "Average ";SAMPLE%(72);" samples per data point"
1350 PRINT "Data points per scan ="; SAMPLE%(78)/2
1360 PRINT "Scans per sample run ="; SCANS
1370 PRINT "Scanning rate =";: PRINT USING "######"; NRATE%
1380 PRINT"Sample run duration ";(SCANS-1)/NRATE%;" seconds"
1390 X=SAMPLE%(76):IF X<0 THEN X=X+65536!
1400 Y=SAMPLE%(77):IF Y<0 THEN Y=Y+65536!
1410 PRINT "Data table from ";STARTTABLE;" to ";X*16+Y
1420 PRINT "Table length =";TABLELENGTH
1430 PRINT:PRINT"Is everything correct (Y/N)? ";:A$=INPUT$(1)
1440 IF A$="Y"OR A$="y" THEN 1460
1450 IF A$="N" OR A$="n" THEN 540 ELSE 1430
1460 GOSUB 2590' try timing
1470 IF EFLAG%=1 THEN EFLAG%=0: NRATE% = 1/ELPS: SAMPLE%(70)= NRATE%: GOTO 1040
1480 CLS: PRINT "Do you want to load an existing data file (Y/N)? ";:                A$= INPUT$(1)
1490 IF A$="N" OR A$="n" THEN 1570
1500 IF A$="Y"OR A$="y" THEN GOTO 2130 ELSE GOTO 1480
1510 CLS
1520 LOCATE 25,10 : PRINT "Press RETURN to leave unchanged.":LOCATE 1,1
1530 FOR N=1 TO SAMPLE%(78)/2
1540 PRINT "Enter control code for data point ";N;" ";:LOCATE ,41:PRINT              SAMPLE%(N);:LOCATE ,40: INPUT A$: IF LEN (A$)>0 THEN SAMPLE%(N)=VAL(A$)
1550 NEXT N
1560 SAMPLE%(N)=SAMPLE%(1)
1570 CLS:PRINT "Review or revise control codes (Y/N)? ";:A$=INPUT$(1)
1580 IF A$="Y"OR A$="y" THEN 1510
1590 IF A$="N" OR A$="n" THEN 1600 ELSE 1570
1600 CLS: PRINT"Press space to begin sampling or R to restart. ";
1610 A$=INPUT$(1): CLS
1620 IF A$= "r" OR A$= "R" THEN B$= CHR$(27): GOTO 2010
1630 IF A$= " " THEN PRINT "Sampling will take";(SCANS-1)/NRATE%; "seconds" ELSE          GOTO 1600
1640 DEF SEG
1650 SBRT=&HFD00
1660 CALL SBRT (SAMPLE%(1))
1670 '
1680 PRINT "Sampling complete."
1690 PRINT "Do you want to save the data as a text file (Y/N)? ";:A$=INPUT$(1)
1700 IF A$="n" OR A$="N" THEN TEXTSAVE = 0: GOTO 1790
1710 IF A$<>"y" AND A$<>"Y" THEN 1690 ELSE TEXTSAVE = 1
1720 CLS: PRINT "Enter the full file specification for a new text file",,                   "or \ for no new file. ";: INPUT FSPEC$
1730 IF FSPEC$="\" THEN TEXTSAVE=0: GOTO 1790
1740 PRINT: PRINT "Save as ";FSPEC$;" ? "; :A$=INPUT$(1)
1750 IF A$="N" OR A$="n" THEN 1720
1760 IF A$<>"Y" AND A$<>"y" THEN 1740
1770 ON ERROR GOTO 2280
1780 OPEN FSPEC$ FOR OUTPUT AS #1: ON ERROR GOTO 0
1790 CLS
1800 DS = STARTTABLE/16
1810 DEF SEG = DS
1820 IF SAMPLE%(67)=8 THEN WRDLEN = 1 ELSE WRDLEN = 2
1830 LOCATE 25,25:PRINT"Press space to pause.":LOCATE 1,1
1840 INDEX = 0
1850 FOR SCAN = 1 TO SCANS
1860 PRINT USING "Scan########";SCAN;: PRINT "    ";
1870 FOR DATAPOINT = 1 TO SAMPLE%(78)/2
1880 IF WRDLEN = 1 THEN PRINT USING "########"; PEEK(INDEX), ELSE PRINT USING          "########"; PEEK(INDEX) + PEEK(INDEX+1)*256,
1890 IF TEXTSAVE=1 THEN IF WRDLEN = 1 THEN PRINT #1, PEEK(INDEX); ELSE PRINT #1,     PEEK(INDEX) + PEEK(INDEX +1)*256;
1900 INDEX=INDEX + WRDLEN
1910 IF INDEX = 65536! THEN INDEX = 0:DS=DS+4096:DEF SEG = DS
1920 NEXT DATAPOINT
1930 PRINT
1940 IF TEXTSAVE = 1 THEN WRITE #1,
1950 IF INKEY$<>"" THEN 1970
1960 NEXT SCAN
1970 ROW=CSRLIN: LOCATE 25,15
1980 PRINT"Press space to continue, R to restart or Esc to exit ";
1990 B$=INPUT$(1)
2000 IF B$=" " AND SCANS >=SCAN THEN LOCATE 25,15: PRINT SPACE$(10);                "Press space to pause.";SPACE$(22);: LOCATE ROW,1: GOTO 1960
2010 CLOSE: CLS
2020 PRINT "Do you want to save the array that defines the sample run (Y/N)? ";
2030 A$ = INPUT$(1)
2040 IF A$="n" OR A$="N" THEN IF B$= CHR$(27) THEN 2070 ELSE 1300
2050 IF A$<>"y" AND A$<>"Y" THEN PRINT: GOTO 2010
2060 DEF SEG: BSAVE "samarray", VARPTR(SAMPLE%(1)), 168
2070 CLS: B$=""
2080 PRINT"Press R to restart or Esc to exit ";
2090 A$=INPUT$(1)
2100 IF A$=CHR$(27) THEN PRINT: PRINT"done": DEF SEG: END
2110 IF A$<>"r" AND A$<>"R" THEN PRINT: GOTO 2080 ELSE GOTO 1300
2120 RESUME NEXT
2130 CLS: REM reprocess files
2140 PRINT"Enter the full file specification of the existing data file to load",     "or the drive letter (A B C or D) for the disk directory",,                     "or \ for no files ";
2150 INPUT A$: CLS: IF A$="\" THEN GOTO 1300
2160 IF LEN(A$)= 0 THEN 2130
2170 IF LEN(A$)>1 THEN 2200 ELSE A= ASC(A$): IF A>95 THEN A= A-32
2180 ON ERROR GOTO 2260
2190 IF A>64 AND A< 69 THEN A$=A$+":*.*": LOCATE 25,20: PRINT                        "Press space to continue": FILES A$: B$=INPUT$(1): LOCATE 25,20: PRINT          SPC(27): GOTO 2140
2200 DEF SEG = STARTTABLE/16
2210 ON ERROR GOTO 2240
2220 BLOAD A$, 0: ON ERROR GOTO 0
2230 CLS: GOTO 1690
2240 PRINT "Can't find file. Press space to continue.": X$=INPUT$(1)
2250 RESUME 2130
2260 CLS: PRINT "No such drive. Press space to continue. ":X$=INPUT$(1)
2270 RESUME 2130
2280 PRINT: PRINT "Can't open file. Press space to continue. ": X$=INPUT$(1)
2290 RESUME 1720
2300 'Timing routine sets TICK= 1 count in a delay loop (in seconds)
2310 ' and sample%(75) to TICK in nanoseconds
2320 IF SAMPLE%(75)= 0 THEN 2350
2330 PRINT "Press T for new timing or space to continue ";:A$=INPUT$(1)
2340 IF A$<> "T" AND A$<> "t" THEN RETURN
2350 CLS: PRINT "Establishing timing, this may take a minute."
2360 FOR N%= 0 TO 13
2370 READ X%
2380 POKE VARPTR(CODE%(0))+N%, X%
2390 NEXT N%
2400 DATA &H55,&H89,&HE5,&H8B,&H5E,&H06,&H8B,&H0F,&HE2,&HFE,&H5D,&HCA,&H02,&H00
2410 C%=1
2420 START = TIMER
2430 SUBR%= VARPTR(CODE%(0))
2440 START = TIMER
2450 FOR N%= 1 TO 5000
2460 CALL SUBR% (C%)
2470 NEXT
2480 OVERHEAD = TIMER - START
2490 C%=2001
2500 START = TIMER
2510 SUBR%= VARPTR(CODE%(0))
2520 START = TIMER
2530 FOR N%= 1 TO 5000
2540 CALL SUBR% (C%)
2550 NEXT
2560 TICK= (TIMER - START - OVERHEAD) * .0000001
2570 SAMPLE%(75)= INT(TICK * 10^9)
2580 RETURN
2590 ' call sample routine and adjust timing
2600 CLS: PRINT "Enter T to verify timing or press space to continue";
2610 A$=INPUT$(1): IF A$<>"T" AND A$<>"t" THEN RETURN
2620 TRYS%= 0
2630 EFLAG%= 0
2640 QRATE = NRATE%
2650 GOSUB 2800
2660 PERIOD= 1/NRATE%
2670 EP=  ELPS/PERIOD: IF EP > 1.007 THEN EFLAG%= 1
2680 IF EP < .993 THEN EFLAG%= 1
2690 TRYS%= TRYS% + 1: IF TRYS%= 3 THEN RETURN
2700 IF EFLAG%= 0 THEN RETURN
2710 DD= (ELPS-PERIOD) / EP
2720 NDELAY= SAMPLE%(74) - INT(DD / (.000038 + TICK * 2) + .5)
2730 IF NDELAY = DELAY THEN IF EP>1 THEN NDELAY= NDELAY-1 ELSE NDELAY= NDELAY+1
2740 IF NDELAY < 0 THEN NDELAY = 0
2750 DELAY= NDELAY
2760 SAMPLE%(74)= DELAY
2770 GOTO 2630
2780 TRYS%=0: TFLAG%=0' establish overhead
2790 TEMPDELAY%= SAMPLE%(74): SAMPLE%(74)=0
2800 CLS: PRINT "This should take under a minute."
2810 TEMPSCANS = SCANS
2820 SCANS= INT(15 * QRATE)
2830 GOSUB 1190' set up dummy run of 15 seconds
2840 SBRT= &HFD00
2850 DEF SEG
2860 TINTERRUPT= SAMPLE%(68): SAMPLE%(68)= 1
2870 POKE SBRT+158, 139: POKE SBRT+271, 139: POKE SBRT+366, 139: POKE SBRT+446,      138: POKE SBRT+539, 138
2880 START= TIMER
2890 CALL SBRT (SAMPLE%(1))
2900 ELPS= ((TIMER-START) + SAMPLE%(74) * (.000038 + TICK * 2))/SCANS
2910 SAMPLE%(68)= TINTERRUPT
2920 SCANS = TEMPSCANS: GOSUB 1190
2930 POKE SBRT+158, 137: POKE SBRT+271, 137: POKE SBRT+366, 137: POKE SBRT+446,      136: POKE SBRT+539, 136
2940 RETURN
